exec("Add-Ons/Client_HexGUI/HexGUI.gui");
exec("./greekbinds.cs");
addKeyBind("GUI", "Hex GUI", "toggleHexGUI");
function toggleHexGUI(%val)
{
	if(!%val)
		return;
	if(HexGUI.isAwake())
		Canvas.popDialog(HexGUI);
	else
		Canvas.pushDialog(HexGUI);
}

function validHex(%hex)
{
	if(strLen(%hex) < 6)
		return false;
	%key = "ABCDEF0123456789";
	for(%i = 0; %i < 6; %i++)
	{
		%char = getSubStr(%hex, %i, 1);
		if(striPos(%key, %char) == -1)
			return false;
	}
	return true;
}

function convertRGBtoHex(%str)
{
	%c0 = getWord(%str, 0);
	%c1 = getWord(%str, 1);
	%c2 = getWord(%str, 2);
	for(%i = 0; %i < 3; %i++)
	{
		%x0 = mFloor(%c[%i] / 16);
		%x1 = mFloor(%c[%i] - 16 * %x0);
		for(%y = 0; %y < 2; %y++)
		{
			switch(%x[%y])
			{
				case 10: %h[%y] = A;
				case 11: %h[%y] = B;
				case 12: %h[%y] = C;
				case 13: %h[%y] = D;
				case 14: %h[%y] = E;
				case 15: %h[%y] = F;
				default: %h[%y] = %x[%y];
			}
		}
		%c[%i] = %h0 @ %h1;
	}
	return %c0 @ %c1 @ %c2;
}

function convertHexToRGB(%str)
{
	for(%i = 0; %i < 6; %i++)
	{
		%c = getSubStr(%str, %i, 1);
		switch$(%c)
		{
			case "A": %x[%i] = 10;
			case "B": %x[%i] = 11;
			case "C": %x[%i] = 12;
			case "D": %x[%i] = 13;
			case "E": %x[%i] = 14;
			case "F": %x[%i] = 15;
			default: %x[%i] = %c;
		}
	}
	return ((%x0 * 16) + %x1) SPC ((%x2 * 16) + %x3) SPC ((%x4 * 16) + %x5);
}
	
function HexGUI_UpdateColour()
{
	%r = mFloor(mFloatLength(HexRedSlider.getValue(), 3) * 255);
	%g = mFloor(mFloatLength(HexGreenSlider.getValue(), 3) * 255);
	%b = mFloor(mFloatLength(HexBlueSlider.getValue(), 3) * 255);
	HexColourDisplay.setColor(%r / 255 SPC %g / 255 SPC %b / 255 SPC "255");
	HexCodeBox.setValue(convertRGBToHex(%r SPC %g SPC %b));
}

function HexGUI_UpdateFromHex()
{
	if(!validHex(HexCodeBox.getValue()))
		return;
	%hex = convertHexToRGB(HexCodeBox.getValue());
	HexRedSlider.setValue(getWord(%hex, 0) / 255);
	HexGreenSlider.setValue(getWord(%hex, 1) / 255);
	HexBlueSlider.setValue(getWord(%hex, 2) / 255);
	HexGUI_UpdateColour();
}